import { createJWT, ES256KSigner, hexToBytes } from "did-jwt";
import { loadConfig } from "../../src/config";

const config = loadConfig();

/**
 * Function to generate the token obtained in the Users
 * Onboarding Web App, which is generated by the Onboarding API
 */
export async function generateTokenWebAppOnboarding(): Promise<string> {
  const jwtOpts = {
    alg: "ES256K",
    issuer: config.api.onboarding.did,
    signer: ES256KSigner(hexToBytes(config.api.onboarding.privateKey)),
  };

  const header = {
    kid: config.api.onboarding.kid,
  };

  const payloadCaptcha = {
    onboarding: "recaptcha",
    validatedInfo: {
      success: true,
      challenge_ts: "2021-05-12T14:14:20Z",
      score: 0.9,
      action: "login",
    },
  };

  return createJWT(payloadCaptcha, jwtOpts, header);
}

export default generateTokenWebAppOnboarding;
